using System;
using System.Collections.Generic;
using System.Text;

namespace Calendar
{
    static class HolidayChecker
    {

        // t̓Ԃ\bh
        public static int Syunbun(int yy)
        {
            int dd = 0;

            try
            {

                if (yy <= 1947)
                {
                    dd = 99;
                }
                else if (yy <= 1979)
                {
                    dd = (int)(20.8357 + (0.242194 * (yy - 1980)) - (int)((yy - 1983) / 4));
                }
                else if (yy <= 2099)
                {
                    dd = (int)(20.8431 + (0.242194 * (yy - 1980)) - (int)((yy - 1980) / 4));
                }
                else if (yy <= 2150)
                {
                    dd = (int)(21.851 + (0.242194 * (yy - 1980)) - (int)((yy - 1980) / 4));
                }
                else
                {
                    dd = 99;
                }
            }
            catch
            {

            }

            return dd;
        }

        // H̓Ԃ\bh
        public static int Syubun(int yy)
        {
            int dd = 0;


            try
            {
                if (yy <= 1947)
                {
                    dd = 99;
                }
                else if (yy <= 1979)
                {
                    dd = (int)(23.2588 + (0.242194 * (yy - 1980)) - (int)((yy - 1983) / 4));
                }
                else if (yy <= 2099)
                {
                    dd = (int)(23.2488 + (0.242194 * (yy - 1980)) - (int)((yy - 1980) / 4));
                }
                else if (yy <= 2150)
                {
                    dd = (int)(24.2488 + (0.242194 * (yy - 1980)) - (int)((yy - 1980) / 4));
                }
                else
                {
                    dd = 99;
                }

            }
            catch
            {

            }


            return dd;
        }

        // ji߂lj
        public struct HolidayInfo
        {
            public enum HOLIDAY
            {
                WEEKDAY = 0, // 
                HOLIDAY = 1, // x
                C_HOLIDAY = 2, // Ux
                SYUKUJITSU = 3, // j
            };
            public HOLIDAY holiday; // ̓̎
            public DayOfWeek week; // ̗̓j
            public String name; // ̓ɖOtĂꍇ̖͂OB
        };
        private static readonly DateTime SYUKUJITSU = new DateTime(1948, 7, 20); // j@{s
        private static readonly DateTime FURIKAE = new DateTime(1973, 07, 12); // U֋xx̊Jn

        // ̓𒲂ׂ郁\bh
        public static HolidayInfo Holiday(DateTime t)
        {
            int yy = t.Year;
            int mm = t.Month;
            int dd = t.Day;
            DayOfWeek ww = t.DayOfWeek;

            HolidayInfo result = new HolidayInfo();
            result.week = ww;
            result.holiday = HolidayInfo.HOLIDAY.WEEKDAY;

            // j@{sȑO
            if (t < SYUKUJITSU) return result;

            try
            {

                switch (mm)
                {
                    // P //
                    case 1:
                        if (dd == 1)
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "";      // 07/5/28 j 'U' ɂȂĂ̂C
                        }
                        else
                        {
                            if (yy >= 2000)
                            {
                                if (((int)((dd - 1) / 7) == 1) && (ww == DayOfWeek.Monday))
                                {
                                    result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                    result.name = "l̓";
                                }
                            }
                            else
                            {
                                if (dd == 15)
                                {
                                    result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                    result.name = "l̓";
                                }
                            }
                        }
                        break;
                    // Q //
                    case 2:
                        if (dd == 11)
                        {
                            if (yy >= 1967)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "LO̓";
                            }
                        }
                        else if ((yy == 1989) && (dd == 24))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "aVc̑r̗";
                        }
                        break;
                    // R //
                    case 3:
                        if (dd == Syunbun(yy))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "t̓";
                        }
                        break;
                    // S //
                    case 4:
                        if (dd == 29)
                        {
                            if (yy >= 2007)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "a̓";
                            }
                            else if (yy >= 1989)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "݂ǂ̓";
                            }
                            else
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "Vca";
                            }
                        }
                        else if ((yy == 1959) && (dd == 10))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "cqmě̋V";
                        }
                        break;
                    // T //
                    case 5:
                        if (dd == 3)
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "@LO";
                        }
                        else if (dd == 4)
                        {
                            if (yy >= 2007)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "݂ǂ̓";
                            }
                            else if (yy >= 1986)
                            {
                                /* 5/4j́w̓jxj́w@LO̐U֋xx(`2006N)*/
                                if (ww > DayOfWeek.Monday)
                                {
                                    result.holiday = HolidayInfo.HOLIDAY.HOLIDAY;
                                    result.name = "̋x";
                                }
                            }
                        }
                        else if (dd == 5)
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "ǂ̓";
                        }
                        else if (dd == 6)
                        {
                            /* 07/11/21  [Wednesday or Thursday]  [Tuesday or Wednesday] ɒ */
                            /* [5/3,5/4j]P[X̂݁AŔ */
                            if ((yy >= 2007) && ((ww == DayOfWeek.Tuesday) || (ww == DayOfWeek.Wednesday)))
                            {
                                result.holiday = HolidayInfo.HOLIDAY.C_HOLIDAY;
                                result.name = "U֋x";
                            }
                        }
                        break;
                    // U //
                    case 6:
                        if ((yy == 1993) && (dd == 9))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "cqmě̋V";
                        }
                        break;
                    // V //
                    case 7:
                        if (yy >= 2003)
                        {
                            if (((int)((dd - 1) / 7) == 2) && (ww == DayOfWeek.Monday))
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "C̓";
                            }
                        }
                        else if (yy >= 1996)
                        {
                            if (dd == 20)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "C̓";
                            }
                        }
                        break;
                    // W //
                    case 8:
                        break;
                    // X //
                    case 9:
                        if (dd == Syubun(yy))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "H̓";
                        }
                        else
                        {
                            if (yy >= 2003)
                            {
                                if (((int)((dd - 1) / 7) == 2) && (ww == DayOfWeek.Monday))
                                {
                                    result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                    result.name = "hV̓";
                                }
                                else if (ww == DayOfWeek.Tuesday)
                                {
                                    if (dd == Syubun(yy) - 1)
                                    {
                                        result.holiday = HolidayInfo.HOLIDAY.HOLIDAY;
                                        result.name = "̋x";
                                    }
                                }
                            }
                            else if (yy >= 1966)
                            {
                                if (dd == 15)
                                {
                                    result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                    result.name = "hV̓";
                                }
                            }
                        }
                        break;
                    // PO //
                    case 10:
                        if (yy >= 2000)
                        {
                            if (((int)((dd - 1) / 7) == 1) && (ww == DayOfWeek.Monday))
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "̈̓";
                            }
                        }
                        else if (yy >= 1966)
                        {
                            if (dd == 10)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "̈̓";
                            }
                        }
                        break;
                    // PP //
                    case 11:
                        if (dd == 3)
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "̓";
                        }
                        else if (dd == 23)
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "ΘJӂ̓";
                        }
                        else if ((yy == 1990) && (dd == 12))
                        {
                            result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                            result.name = "ʗ琳a̋V";
                        }
                        break;
                    // PQ //
                    case 12:
                        if (dd == 23)
                        {
                            if (yy >= 1989)
                            {
                                result.holiday = HolidayInfo.HOLIDAY.SYUKUJITSU;
                                result.name = "Vca";
                            }
                        }
                        break;
                    default:
                        break;
                }

                if ((result.holiday == HolidayInfo.HOLIDAY.WEEKDAY || result.holiday == HolidayInfo.HOLIDAY.HOLIDAY) && (ww == DayOfWeek.Monday))
                {
                    /*jȊO͐U֋xsv
                      5/6(,)̔͏LXebvŏ
                      5/6()͂Ŕ肷  */
                    if (t >= FURIKAE)
                    {
                        if (Holiday(t.AddDays(-1)).holiday == HolidayInfo.HOLIDAY.SYUKUJITSU)
                        {    /* ċAďo */
                            result.holiday = HolidayInfo.HOLIDAY.C_HOLIDAY;
                            result.name = "U֋x";
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }

            return result;
        }


    }
}
