﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Calendar.Resources;

namespace Calendar
{
    public partial class MainPage : PhoneApplicationPage
    {
        // コンストラクター
        public MainPage()
        {
            InitializeComponent();

            // ApplicationBar をローカライズするためのサンプル コード
            //BuildLocalizedApplicationBar();

            //マイナス何日するのか記憶する変数
            int int_StartDay = 0;


            //現在の日付を記憶する変数(今月は0）
            DateTime dt_Now = DateTime.Now.AddMonths(0);


            //タイトルに○年○月と入れる
            YearMonth.Text = dt_Now.ToString("yyyy年MM月");


            //1日の曜日を調べる
            DateTime dt_FirstDay = DateTime.Parse(dt_Now.ToString("yyyy/MM/01 00:00:00"));


            //1日の曜日を調べて最初のマスをマイナス何日すればいいか変数に代入する。
            switch (dt_FirstDay.DayOfWeek)
            {
                case DayOfWeek.Sunday:
                    int_StartDay = 0;
                    break;
                case DayOfWeek.Monday:
                    int_StartDay = 1;
                    break;
                case DayOfWeek.Tuesday:
                    int_StartDay = 2;
                    break;
                case DayOfWeek.Wednesday:
                    int_StartDay = 3;
                    break;
                case DayOfWeek.Thursday:
                    int_StartDay = 4;
                    break;
                case DayOfWeek.Friday:
                    int_StartDay = 5;
                    break;
                case DayOfWeek.Saturday:
                    int_StartDay = 6;
                    break;
            }

            //最初のマスの日付を設定する
            dt_Now = dt_FirstDay.AddDays(-int_StartDay);

            //カウント（初期化）
            int count = 0;


            for (int y = 1; y <= 6; ++y) // Row 6行
            {
                for (int x = 0; x <= 6; ++x) // Column 日～土
                {

                    //ボーダー線を作成
                    Border b = new Border();

                    //パネルの子供にする
                    ContentPanel.Children.Add(b);

                    //パネルのグリッド位置設定
                    System.Windows.Controls.Grid.SetColumn(b, x);
                    System.Windows.Controls.Grid.SetRow(b, y);

                    //線の太さ
                    Thickness t = new Thickness(1);
                    b.BorderThickness = t;

                    //線のマージンを設定
                    Thickness t2 = new Thickness(-1, -1, 0, 0);
                    b.Margin = t2;

                    //ボーダー線の色を設定
                    b.BorderBrush = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 170, 170, 170));

                    //バックカラーを設定。今月以外は灰色、日曜日、祝日はピンク、土曜日は水色にする。
                    if (dt_Now.AddDays(count).ToString("yyyy年MM月") == YearMonth.Text)
                    {
                        //曜日チェック
                        switch (dt_Now.AddDays(count).DayOfWeek)
                        {
                            case DayOfWeek.Sunday:
                                //日曜日はピンク
                                b.Background = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 247, 223, 223));
                                break;
                            case DayOfWeek.Saturday:
                                //土曜日は水色
                                b.Background = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 223, 223, 247));
                                break;
                            default:


                                //祝日チェックし、平日なら白、祝日ならピンクにする。
                                if (HolidayChecker.Holiday(dt_Now.AddDays(count)).holiday == HolidayChecker.HolidayInfo.HOLIDAY.WEEKDAY)
                                {
                                    b.Background = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 255, 255, 255));

                                }
                                else
                                {
                                    b.Background = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 247, 223, 223));
                                }
                                break;
                        }

                    }
                    else
                    {

                        //当月以外は灰色
                        b.Background = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 230, 230, 230));

                    }

                    //テキストブロックを作成
                    TextBlock txt = new TextBlock();

                    //ボーダーの子供にする
                    b.Child = txt;

                    //テキストブロックの折り返しを設定
                    txt.TextWrapping = TextWrapping.Wrap;

                    //マージンを設定。線の内側3ピクセル分にする
                    Thickness t3 = new Thickness(3);
                    txt.Margin = t3;

                    //フォントサイズを設定する
                    txt.FontSize = 16;

                    //文字の色を設定する
                    txt.Foreground = new System.Windows.Media.SolidColorBrush(System.Windows.Media.Color.FromArgb(255, 0, 0, 0));

                    //文字の水平位置を左にする
                    txt.TextAlignment = TextAlignment.Left;

                    //文字の垂直位置を上にする
                    txt.VerticalAlignment = VerticalAlignment.Top;

                    //文字を設定。1行目は日付の数字。改行して好きな文字を入れる。
                    txt.Text = dt_Now.AddDays(count).ToString("%d") + "\n";

                    //カウントを+1する。
                    count += 1;

                }
            }


        }

        // ローカライズされた ApplicationBar を作成するためのサンプル コード
        //private void BuildLocalizedApplicationBar()
        //{
        //    // ページの ApplicationBar を ApplicationBar の新しいインスタンスに設定します。
        //    ApplicationBar = new ApplicationBar();

        //    // 新しいボタンを作成し、テキスト値を AppResources のローカライズされた文字列に設定します。
        //    ApplicationBarIconButton appBarButton = new ApplicationBarIconButton(new Uri("/Assets/AppBar/appbar.add.rest.png", UriKind.Relative));
        //    appBarButton.Text = AppResources.AppBarButtonText;
        //    ApplicationBar.Buttons.Add(appBarButton);

        //    // AppResources のローカライズされた文字列で、新しいメニュー項目を作成します。
        //    ApplicationBarMenuItem appBarMenuItem = new ApplicationBarMenuItem(AppResources.AppBarMenuItemText);
        //    ApplicationBar.MenuItems.Add(appBarMenuItem);
        //}
    }
}